=== include/CMakeLists.txt ===
ADD_SUBDIRECTORY(tins)
