=== include/tins/CMakeLists.txt ===
FILE(GLOB INCLUDE_FILES "*.h")
INSTALL(
    FILES ${INCLUDE_FILES} 
    DESTINATION include/tins
    COMPONENT Headers
)
ADD_SUBDIRECTORY(dot11)
ADD_SUBDIRECTORY(tcp_ip)
