=== include/tins/dot11/CMakeLists.txt ===
FILE(GLOB INCLUDE_FILES "*.h")
INSTALL(
    FILES ${INCLUDE_FILES} 
    DESTINATION include/tins/dot11
    COMPONENT Headers
)
