=== include/tins/tcp_ip/CMakeLists.txt ===
FILE(GLOB INCLUDE_FILES "*.h")
INSTALL(
    FILES ${INCLUDE_FILES} 
    DESTINATION include/tins/tcp_ip
    COMPONENT Headers
)
