## libtins 1.1

=== debian/changelog ===
libtins (1.1-1) unstable; urgency=low

  * New upstream version
  * Added libssl-dev as a build dependency

 -- Raúl Benencia <rul@kalgan.cc>  Fri, 08 Jul 2013 19:15:21 -0300

libtins (0.3-1) unstable; urgency=low

  * Initial release (Closes: #692778)

 -- Raúl Benencia <rul@kalgan.cc>  Tue, 02 Feb 2013 15:00:39 -0300
