=== debian/control ===
Source: libtins
Priority: extra
Maintainer: Raúl Benencia <rul@kalgan.cc>
Build-Depends: debhelper (>= 9), dh-autoreconf, libpcap-dev, libssl-dev, pkg-kde-tools
Standards-Version: 3.9.4
Section: libs
Homepage: http://libtins.sourceforge.net/
Vcs-Git: git://gitorious.org/debianstuff/debian-pkg-libtins.git
Vcs-Browser: https://gitorious.org/debianstuff/debian-pkg-libtins/trees/master

Package: libtins1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ library for manipulating raw network packets
 The library's main purpose is to provide the C++ developer an easy,
 efficient, platform and endianess-independent way to create tools which
 need to send, receive and manipulate specially crafted packets.

Package: libtins-dev
Section: libdevel
Architecture: any
Depends: libtins1 (= ${binary:Version}), ${misc:Depends}
Description: C++ library for manipulating raw network packets (development files)
 The library's main purpose is to provide the C++ developer an easy,
 efficient, platform and endianess-independent way to create tools which
 need to send, receive and manipulate specially crafted packets.
 .
 This package contains the development files of libtins.

Package: libtins1-dbg
Section: debug
Architecture: any
Multi-Arch: same
Depends: libtins1 (= ${binary:Version}), ${misc:Depends}
Description: C++ library for manipulating raw network packets (debug files)
 The library's main purpose is to provide the C++ developer an easy,
 efficient, platform and endianess-independent way to create tools which
 need to send, receive and manipulate specially crafted packets.
 .
 This package contains the debugging symbols for libtins1.
