=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@ --dbg-package=libtins1-dbg --with=autoreconf --with=pkgkde_symbolshelper

override_dh_auto_configure:
	dh_auto_configure -- --enable-c++11

override_dh_makeshlibs:
	dh_makeshlibs -- -c0
