=== debian/watch ===
version=3
http://sf.net/libtins/libtins-(.*)\.tar\.gz
