## libtins 2.0

=== debian/changelog ===
libtins (2.0-1) unstable; urgency=low

  * New upstream version
  * Bump Standards-Version to 3.9.5 (no changes)
  * Upstream is now hosted on github. Update d/watch, d/copyright and
    d/control in order to reflect this change.

 -- Raúl Benencia <rul@kalgan.cc>  Sat, 08 Feb 2014 18:32:02 -0300
