=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Priority: extra
 Maintainer: Raúl Benencia <rul@kalgan.cc>
 Build-Depends: debhelper (>= 9), dh-autoreconf, libpcap-dev, libssl-dev, pkg-kde-tools
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Section: libs
-Homepage: http://libtins.sourceforge.net/
+Homepage: http://libtins.github.io/
 Vcs-Git: git://gitorious.org/debianstuff/debian-pkg-libtins.git
 Vcs-Browser: https://gitorious.org/debianstuff/debian-pkg-libtins/trees/master
 
-Package: libtins1
+Package: libtins2
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
@@ -21,7 +21,7 @@
 Package: libtins-dev
 Section: libdevel
 Architecture: any
-Depends: libtins1 (= ${binary:Version}), ${misc:Depends}
+Depends: libtins2 (= ${binary:Version}), ${misc:Depends}
 Description: C++ library for manipulating raw network packets (development files)
  The library's main purpose is to provide the C++ developer an easy,
  efficient, platform and endianess-independent way to create tools which
@@ -29,14 +29,14 @@
  .
  This package contains the development files of libtins.
 
-Package: libtins1-dbg
+Package: libtins2-dbg
 Section: debug
 Architecture: any
 Multi-Arch: same
-Depends: libtins1 (= ${binary:Version}), ${misc:Depends}
+Depends: libtins2 (= ${binary:Version}), ${misc:Depends}
 Description: C++ library for manipulating raw network packets (debug files)
  The library's main purpose is to provide the C++ developer an easy,
  efficient, platform and endianess-independent way to create tools which
  need to send, receive and manipulate specially crafted packets.
  .
- This package contains the debugging symbols for libtins1.
+ This package contains the debugging symbols for libtins2.
