## libtins 3.4

=== debian/changelog ===
libtins (3.4-2build1) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 05 Feb 2018 16:50:50 +0000

libtins (3.4-2) unstable; urgency=medium

  * Include usr/lib/libtins.so, minor fixes.

 -- Federico Ceratto <federico@debian.org>  Thu, 16 Jun 2016 18:24:52 +0100

libtins (3.4-1) unstable; urgency=medium

  * Initial release (Closes: #825025)

 -- Federico Ceratto <federico@debian.org>  Mon, 06 Jun 2016 11:24:23 +0100
