=== debian/control ===
Source: libtins
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Internet Measurement Packaging Team <pkg-netmeasure-discuss@lists.alioth.debian.org>
Uploaders: Federico Ceratto <federico@debian.org>
Build-Depends: debhelper (>=9),
 cmake,
 libpcap-dev,
 libssl-dev
Standards-Version: 3.9.8
Section: libs
Homepage: https://libtins.github.io/
Vcs-Git: https://anonscm.debian.org/git/collab-maint/libtins.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libtins.git

Package: libtins3.4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: packet crafting and sniffing library
 libtins is a high-level, multiplatform C++ network packet sniffing and
 crafting library.
 Its main purpose is to provide the C++ developer an easy, efficient, platform
 and endianess-independent way to create tools which need to send, receive and
 manipulate network packets.

Package: libtins-dev
Section: libdevel
Architecture: any
Depends: libtins3.4 (= ${binary:Version}), ${misc:Depends}
Description: packet crafting and sniffing library - development files
 libtins is a high-level, multiplatform C++ network packet sniffing and
 crafting library.
 Its main purpose is to provide the C++ developer an easy, efficient, platform
 and endianess-independent way to create tools which need to send, receive and
 manipulate network packets.
 This package contains development files.
