=== debian/watch ===
version=3

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/libtins3-$1\.tar\.gz/ \
  https://github.com/mfontanini/libtins/tags .*/v?(\d\S*)\.tar\.gz
